﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Telerik.WinControls.UI;
using Telerik.WinControls.UI.Docking;

namespace RadDockExample
{
    public partial class Form1 : RadForm
    {
        private List<string> docs = new List<string>();

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.IsMdiContainer = true;
            this.radDock1.AutoDetectMdiChildren = true;

            DragDropService service = radDock1.GetService<DragDropService>();
            service.PreviewDockPosition += service_PreviewDockPosition;

            this.radDock1.MdiChildrenDockType = DockType.ToolWindow;

            Form childForm = new Form();
            childForm.Text = "MDI Child 1";
            childForm.MdiParent = this;
            childForm.Show();

            childForm = new Form();
            childForm.Text = "MDI Child 2";
            childForm.MdiParent = this;
            childForm.Show();

            childForm = new Form();
            childForm.Text = "MDI Child 3";
            childForm.MdiParent = this;
            childForm.Show();

            foreach (DockWindow dw in radDock1.DockWindows)
            {
                dw.AllowedDockState = AllowedDockState.TabbedDocument | AllowedDockState.Floating | AllowedDockState.Hidden;
                this.docs.Add(dw.Text);
            }

            ToolWindow tool1 = new ToolWindow("Tool1");            
            tool1.AllowedDockState = AllowedDockState.Docked | AllowedDockState.Floating | AllowedDockState.AutoHide | AllowedDockState.Hidden;
            this.radDock1.DockWindow(tool1, DockPosition.Left);
            ToolWindow tool2 = new ToolWindow("Tool2");
            tool2.AllowedDockState = AllowedDockState.Docked | AllowedDockState.Floating | AllowedDockState.AutoHide | AllowedDockState.Hidden;
            this.radDock1.DockWindow(tool2, DockPosition.Right);
        }

        private void service_PreviewDockPosition(object sender, DragDropDockPositionEventArgs e)
        {
            DragDropService dds = sender as DragDropService;
            DockPopupForm f = dds.Context as DockPopupForm;

            if (f != null && this.docs.Contains(f.Text))
            {
                if (e.DropTarget is DocumentContainer)
                {
                    e.AllowedDockPosition = AllowedDockPosition.Fill;
                    dds.AllowedDockManagerEdges = AllowedDockPosition.None;
                }
                else
                {
                    e.AllowedDockPosition = AllowedDockPosition.None;
                    dds.AllowedDockManagerEdges = AllowedDockPosition.None;
                }
            }
            else
            {
                if (e.DropTarget is DocumentContainer)
                {
                    e.AllowedDockPosition = AllowedDockPosition.None;
                }
                else
                {
                    e.AllowedDockPosition = AllowedDockPosition.All;
                }

                dds.AllowedDockManagerEdges = AllowedDockPosition.All;
            }
        }
    }
}
